All patches and comments are welcome. Please squash your changes to logical
commits before using git-format-patch and git-send-email to
patches@git.madduck.net.
If you'd read over the Git project's submission guidelines and adhered to them,
I'd be especially grateful.
3 # This program is licensed under the GNU GPL version 2 or later.
4 # (c) Richard "RichiH" Hartmann <richih@debian.org>, 2011-2014
5 # For details, see LICENSE. To submit patches, you have to agree to
6 # license your code under the GNU GPL version 2 or later.
8 # While the following is not legally binding, the author would like to
9 # explain the choice of GPLv2+ over GPLv3+.
10 # The author prefers GPLv3+ over GPLv2+ but feels it's better to maintain
11 # full compatibility's with Git. In case Git ever changes its licensing terms,
12 # which is admittedly extremely unlikely to the point of being impossible,
13 # this software will most likely follow suit.
15 # This should always be the first line of code to facilitate debugging
16 [ -n "$VCSH_DEBUG" ] && set -vx
19 # If '.git-HEAD' is appended to the version, you are seeing an unreleased
20 # version of vcsh; the master branch is supposed to be clean at all times
21 # so you can most likely just use it nonetheless
26 echo "$SELF: fatal: $1" >&2
30 # We need to run getops as soon as possible so we catch -d and other
31 # options that will modify our behaviour.
32 # Commands are handled at the end of this script.
33 while getopts "c:dv" flag; do
34 if [ "$1" = '-d' ] || [ "$1" = '--debug' ]; then
39 elif [ "$1" = '-v' ]; then
41 echo "verbose mode on"
43 elif [ "$1" = '-c' ]; then
44 VCSH_OPTION_CONFIG=$OPTARG
50 # Source file even if it's in $PWD and does not have any slashes in it
58 # Read configuration and set defaults if anything's not set
59 [ -n "$VCSH_DEBUG" ] && set -vx
60 : ${XDG_CONFIG_HOME:=$HOME/.config}
62 # Read configuration files if there are any
63 [ -r "/etc/vcsh/config" ] && . "/etc/vcsh/config"
64 [ -r "$XDG_CONFIG_HOME/vcsh/config" ] && . "$XDG_CONFIG_HOME/vcsh/config"
65 if [ -n "$VCSH_OPTION_CONFIG" ]; then
66 # Source $VCSH_OPTION_CONFIG if it can be read and is in $PWD of $PATH
67 if [ -r "$VCSH_OPTION_CONFIG" ]; then
68 source_all "$VCSH_OPTION_CONFIG"
70 fatal "Can not read configuration file '$VCSH_OPTION_CONFIG'" 1
73 [ -n "$VCSH_DEBUG" ] && set -vx
76 : ${VCSH_REPO_D:=$XDG_CONFIG_HOME/vcsh/repo.d}
77 : ${VCSH_HOOK_D:=$XDG_CONFIG_HOME/vcsh/hooks-enabled}
79 : ${VCSH_GITIGNORE:=exact}
80 : ${VCSH_GITATTRIBUTES:=none}
81 : ${VCSH_WORKTREE:=absolute}
83 if [ ! "x$VCSH_GITIGNORE" = 'xexact' ] && [ ! "x$VCSH_GITIGNORE" = 'xnone' ] && [ ! "x$VCSH_GITIGNORE" = 'xrecursive' ]; then
84 fatal "'\$VCSH_GITIGNORE' must equal 'exact', 'none', or 'recursive'" 1
87 if [ ! "x$VCSH_WORKTREE" = 'xabsolute' ] && [ ! "x$VCSH_WORKTREE" = 'xrelative' ]; then
88 fatal "'\$VCSH_WORKTREE' must equal 'absolute', or 'relative'" 1
93 echo "usage: $SELF <options> <command>
98 -v Enable verbose mode
102 [<repo>] Clone from an existing repository
103 commit Commit in all repositories
104 delete <repo> Delete an existing repository
105 enter <repo> Enter repository; spawn new instance of \$SHELL
106 help Display this help text
107 init <repo> Initialize a new repository
108 list List all repositories
109 list-tracked List all files tracked by vcsh
111 <repo> List files tracked by a repository
112 pull Pull from all vcsh remotes
113 push Push to vcsh remotes
115 <newname> Rename repository
117 <command> Use this repository
118 status [<repo>] Show statuses of all/one vcsh repositories
119 upgrade <repo> Upgrade repository to currently recommended settings
120 version Print version information
121 which <substring> Find substring in name of any tracked file
123 <repo> Write .gitignore.d/<repo> via git ls-files
125 <repo> <git command> Shortcut to run git commands directly
126 <repo> Shortcut to enter repository" >&2
130 [ -n "$VCSH_DEBUG" ] && echo "$SELF: debug: $@"
134 if [ -n "$VCSH_DEBUG" ] || [ -n "$VCSH_VERBOSE" ]; then echo "$SELF: verbose: $@"; fi
138 echo "$SELF: error: $1" >&2
142 echo "$SELF: info: $1"
148 git remote add origin "$GIT_REMOTE"
149 git config branch.master.remote origin
150 git config branch.master.merge refs/heads/master
151 if [ $(git ls-remote origin master 2> /dev/null | wc -l ) -lt 1 ]; then
152 info "remote is empty, not merging anything"
157 git ls-tree -r --name-only origin/master | (while read object; do
159 error "'$object' exists." &&
162 [ "$VCSH_CONFLICT" = '1' ]) &&
163 fatal "will stop after fetching and not try to merge!
164 Once this situation has been resolved, run 'vcsh $VCSH_REPO_NAME pull' to finish cloning." 17
165 git merge origin/master
169 hook post-clone-retired
174 for VCSH_REPO_NAME in $(list); do
175 echo "$VCSH_REPO_NAME: "
176 export GIT_DIR="$VCSH_REPO_D/$VCSH_REPO_NAME.git"
178 git commit --untracked-files=no --quiet
179 VCSH_COMMAND_RETURN_CODE=$?
186 cd "$VCSH_BASE" || fatal "could not enter '$VCSH_BASE'" 11
188 info "This operation WILL DESTROY DATA!"
189 files=$(git ls-files)
190 echo "These files will be deleted:
194 AGAIN, THIS WILL DELETE YOUR DATA!
195 To continue, type 'Yes, do as I say'"
197 [ "x$answer" = 'xYes, do as I say' ] || exit 16
198 for file in $files; do
199 rm -f $file || info "could not delete '$file', continuing with deletion"
201 rm -rf "$GIT_DIR" || error "could not delete '$GIT_DIR'"
212 [ -d "$GIT_DIR" ] || fatal "no repository found for '$VCSH_REPO_NAME'" 12
216 for hook in $VCSH_HOOK_D/$1* $VCSH_HOOK_D/$VCSH_REPO_NAME.$1*; do
217 [ -x "$hook" ] || continue
218 verbose "executing '$hook'"
225 [ ! -e "$GIT_DIR" ] || fatal "'$GIT_DIR' exists" 10
226 mkdir -p "$VCSH_BASE" || fatal "could not create '$VCSH_BASE'" 50
227 cd "$VCSH_BASE" || fatal "could not enter '$VCSH_BASE'" 11
228 git init --shared=0600
234 for repo in "$VCSH_REPO_D"/*.git; do
235 [ -d "$repo" ] && [ -r "$repo" ] && echo $(basename "$repo" .git)
240 export GIT_DIR="$VCSH_REPO_D/$VCSH_REPO_NAME.git"
245 for VCSH_REPO_NAME in $(list); do
252 git ls-files | sort -u
257 for VCSH_REPO_NAME in $(list); do
258 printf "$VCSH_REPO_NAME: "
259 export GIT_DIR="$VCSH_REPO_D/$VCSH_REPO_NAME.git"
262 VCSH_COMMAND_RETURN_CODE=$?
270 for VCSH_REPO_NAME in $(list); do
271 printf "$VCSH_REPO_NAME: "
272 export GIT_DIR="$VCSH_REPO_D/$VCSH_REPO_NAME.git"
275 VCSH_COMMAND_RETURN_CODE=$?
287 [ -d "$GIT_DIR_NEW" ] && fatal "'$GIT_DIR_NEW' exists" 54
288 mv -f "$GIT_DIR" "$GIT_DIR_NEW" || fatal "Could not mv '$GIT_DIR' '$GIT_DIR_NEW'" 52
290 # Now that the repository has been renamed, we need to fix up its configuration
291 # Overwrite old name..
292 GIT_DIR="$GIT_DIR_NEW"
293 VCSH_REPO_NAME="$VCSH_REPO_NAME_NEW"
294 # ..and clobber all old configuration
302 VCSH_COMMAND_RETURN_CODE=$?
307 if [ ! "x$VCSH_REPO_NAME" = "x" ]; then
308 export GIT_DIR="$VCSH_REPO_D/$VCSH_REPO_NAME.git"
310 git status --short --untracked-files='no'
311 VCSH_COMMAND_RETURN_CODE=$?
313 for VCSH_REPO_NAME in $(list); do
314 echo "$VCSH_REPO_NAME:"
315 export GIT_DIR="$VCSH_REPO_D/$VCSH_REPO_NAME.git"
317 git status --short --untracked-files='no'
318 VCSH_COMMAND_RETURN_CODE=$?
326 # fake-bare repositories are not bare, actually. Set this to false
327 # because otherwise Git complains "fatal: core.bare and core.worktree
329 git config core.bare false
330 # core.worktree may be absolute or relative to $GIT_DIR, depending on
332 if [ ! "x$VCSH_WORKTREE" = 'xabsolute' ]; then
333 git config core.worktree $(cd $GIT_DIR && GIT_WORK_TREE="$VCSH_BASE" git rev-parse --show-cdup)
334 elif [ ! "x$VCSH_WORKTREE" = 'xrelative' ]; then
335 git config core.worktree "$VCSH_BASE"
337 [ ! "x$VCSH_GITIGNORE" = 'xnone' ] && git config core.excludesfile ".gitignore.d/$VCSH_REPO_NAME"
338 [ ! "x$VCSH_GITATTRIBUTES" = 'xnone' ] && git config core.attributesfile ".gitattributes.d/$VCSH_REPO_NAME"
339 git config vcsh.vcsh 'true'
341 [ -e "$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME" ] && git add -f "$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME"
342 [ -e "$VCSH_BASE/.gitattributes.d/$VCSH_REPO_NAME" ] && git add -f "$VCSH_BASE/.gitattributes.d/$VCSH_REPO_NAME"
348 export VCSH_DIRECTORY="$VCSH_REPO_NAME"
352 for VCSH_REPO_NAME in $(list); do
353 for VCSH_FILE in $(get_files); do
354 echo $VCSH_FILE | grep -q "$VCSH_COMMAND_PARAMETER" && echo "$VCSH_REPO_NAME: $VCSH_FILE"
360 # Don't do anything if the user does not want to write gitignore
361 if [ "x$VCSH_GITIGNORE" = 'xnone' ]; then
362 info "Not writing gitignore as '\$VCSH_GITIGNORE' is set to 'none'"
367 cd "$VCSH_BASE" || fatal "could not enter '$VCSH_BASE'" 11
370 gitignores=$(for file in $(git ls-files); do
372 echo $file; new="${file%/*}"
373 [ "$file" = "$new" ] && break
378 # Contrary to GNU mktemp, mktemp on BSD/OSX requires a template for temp files
379 # Using a template makes GNU mktemp default to $PWD and not #TMPDIR for tempfile location
380 # To make every OS happy, set full path explicitly
381 tempfile=$(mktemp "${TMPDIR:-/tmp}/tmp.XXXXXXXXXX") || fatal "could not create tempfile: '${tempfile}'" 51
383 echo '*' > "$tempfile" || fatal "could not write to '$tempfile'" 57
384 for gitignore in $gitignores; do
385 echo "$gitignore" | sed 's@^@!/@' >> "$tempfile" || fatal "could not write to '$tempfile'" 57
386 if [ "x$VCSH_GITIGNORE" = 'xrecursive' ] && [ -d "$gitignore" ]; then
387 { echo "$gitignore/*" | sed 's@^@!/@' >> "$tempfile" || fatal "could not write to '$tempfile'" 57; }
391 if diff -N "$tempfile" "$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME" > /dev/null; then
392 rm -f "$tempfile" || error "could not delete '$tempfile'"
395 if [ -e "$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME" ]; then
396 info "'$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME' differs from new data, moving it to '$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME.bak'"
397 mv -f "$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME" "$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME.bak" ||
398 fatal "could not move '$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME' to '$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME.bak'" 53
400 mv -f "$tempfile" "$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME" ||
401 fatal "could not move '$tempfile' to '$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME'" 53
406 if [ ! "x$VCSH_GITIGNORE" = 'xexact' ] && [ ! "x$VCSH_GITIGNORE" = 'xnone' ] && [ ! "x$VCSH_GITIGNORE" = 'xrecursive' ]; then
407 fatal "'\$VCSH_GITIGNORE' must equal 'exact', 'none', or 'recursive'" 1
410 export VCSH_COMMAND="$1"
412 case "$VCSH_COMMAND" in
413 clon|clo|cl) VCSH_COMMAND=clone;;
414 commi|comm|com|co) VCSH_COMMAND=commit;;
415 delet|dele|del|de) VCSH_COMMAND=delete;;
416 ente|ent|en) VCSH_COMMAND=enter;;
417 hel|he) VCSH_COMMAND=help;;
418 ini|in) VCSH_COMMAND=init;;
419 pul) VCSH_COMMAND=pull;;
420 pus) VCSH_COMMAND=push;;
421 renam|rena|ren|re) VCSH_COMMAND=rename;;
422 ru) VCSH_COMMAND=run;;
423 statu|stat|sta|st) VCSH_COMMAND=status;;
424 upgrad|upgra|upgr|up) VCSH_COMMAND=upgrade;;
425 versio|versi|vers|ver|ve) VCSH_COMMAND=version;;
426 which|whi|wh) VCSH_COMMAND=which;;
427 write|writ|wri|wr) VCSH_COMMAND=write-gitignore;;
430 if [ "$VCSH_COMMAND" = 'clone' ]; then
431 [ -z "$2" ] && fatal "$VCSH_COMMAND: please specify a remote" 1
433 [ -n "$3" ] && VCSH_REPO_NAME="$3" || VCSH_REPO_NAME=$(basename "${GIT_REMOTE#*:}" .git)
434 [ -z "$VCSH_REPO_NAME" ] && fatal "$VCSH_COMMAND: could not determine repository name" 1
435 export VCSH_REPO_NAME
436 export GIT_DIR="$VCSH_REPO_D/$VCSH_REPO_NAME.git"
437 elif [ "$VCSH_COMMAND" = 'version' ]; then
438 echo "$SELF $VERSION"
441 elif [ "$VCSH_COMMAND" = 'which' ]; then
442 [ -z "$2" ] && fatal "$VCSH_COMMAND: please specify a filename" 1
443 [ -n "$3" ] && fatal "$VCSH_COMMAND: too many parameters" 1
444 export VCSH_COMMAND_PARAMETER="$2"
445 elif [ "$VCSH_COMMAND" = 'delete' ] ||
446 [ "$VCSH_COMMAND" = 'enter' ] ||
447 [ "$VCSH_COMMAND" = 'init' ] ||
448 [ "$VCSH_COMMAND" = 'list-tracked-by' ] ||
449 [ "$VCSH_COMMAND" = 'rename' ] ||
450 [ "$VCSH_COMMAND" = 'run' ] ||
451 [ "$VCSH_COMMAND" = 'upgrade' ] ||
452 [ "$VCSH_COMMAND" = 'write-gitignore' ]; then
453 [ -z $2 ] && fatal "$VCSH_COMMAND: please specify repository to work on" 1
454 [ "$VCSH_COMMAND" = 'rename' -a -z "$3" ] && fatal "$VCSH_COMMAND: please specify a target name" 1
455 [ "$VCSH_COMMAND" = 'run' -a -z "$3" ] && fatal "$VCSH_COMMAND: please specify a command" 1
456 export VCSH_REPO_NAME="$2"
457 export GIT_DIR="$VCSH_REPO_D/$VCSH_REPO_NAME.git"
458 [ "$VCSH_COMMAND" = 'rename' ] && { export VCSH_REPO_NAME_NEW="$3";
459 export GIT_DIR_NEW="$VCSH_REPO_D/$VCSH_REPO_NAME_NEW.git"; }
460 [ "$VCSH_COMMAND" = 'run' ] && shift 2
461 elif [ "$VCSH_COMMAND" = 'commit' ] ||
462 [ "$VCSH_COMMAND" = 'list' ] ||
463 [ "$VCSH_COMMAND" = 'list-tracked' ] ||
464 [ "$VCSH_COMMAND" = 'pull' ] ||
465 [ "$VCSH_COMMAND" = 'push' ]; then
467 elif [ "$VCSH_COMMAND" = 'status' ]; then
468 export VCSH_REPO_NAME="$2"
469 elif [ -n "$2" ]; then
470 export VCSH_COMMAND='run'
471 export VCSH_REPO_NAME="$1"
472 export GIT_DIR="$VCSH_REPO_D/$VCSH_REPO_NAME.git"
473 [ -d $GIT_DIR ] || { help; exit 1; }
476 elif [ -n "$VCSH_COMMAND" ]; then
477 export VCSH_COMMAND='enter'
478 export VCSH_REPO_NAME="$1"
479 export GIT_DIR="$VCSH_REPO_D/$VCSH_REPO_NAME.git"
480 [ -d $GIT_DIR ] || { help; exit 1; }
482 # $1 is empty, or 'help'
486 # Did we receive a directory instead of a name?
487 # Mangle the input to fit normal operation.
488 if echo $VCSH_REPO_NAME | grep -q '/'; then
489 export GIT_DIR=$VCSH_REPO_NAME
490 export VCSH_REPO_NAME=$(basename "$VCSH_REPO_NAME" .git)
495 if [ ! -d "$check_directory" ]; then
496 if [ -e "$check_directory" ]; then
497 fatal "'$check_directory' exists but is not a directory" 13
499 verbose "attempting to create '$check_directory'"
500 mkdir -p "$check_directory" || fatal "could not create '$check_directory'" 50
505 check_dir "$VCSH_REPO_D"
506 [ ! "x$VCSH_GITIGNORE" = 'xnone' ] && check_dir "$VCSH_BASE/.gitignore.d"
507 [ ! "x$VCSH_GITATTRIBUTES" = 'xnone' ] && check_dir "$VCSH_BASE/.gitattributes.d"
509 verbose "$VCSH_COMMAND begin"
510 export VCSH_COMMAND=$(echo $VCSH_COMMAND | sed 's/-/_/g')
514 verbose "$VCSH_COMMAND end, exiting"
515 exit $VCSH_COMMAND_RETURN_CODE